<?php

    /*
        RStack云平台，复制请保留版权：http://www.rstack.com.cn/
        update:2023-02-14
    */
    define('virtualType', 'vhost');
    define('moduleName', 'rstackVHOST');

	if(!function_exists('vlang_vars_name')){
		function vlang_vars_name($str, $array){

			foreach($array as $k => $v){

				$str = str_replace('{{'.$k.'}}', $v, $str);

			}
			return $str;
		}
	}

	//创建云虚拟主机
	function rstackVHOST_CreateAccount($params){
		 $userid = $params["userid"];
		 $serviceid = $params["serviceid"];
		 $domain = $params["domain"]; 
		 $hostname = $params["username"];
		 if ($hostname ==""){
		     //随机生成FTP名字
		     $hostname = "vhost".rstackVHOST_generate_str(9,3);
		 }
		 $vpsPassword = $params["password"];
		 //初始化判断是否免费的套餐
		 $query = mysql_query("SELECT * FROM tblhosting WHERE id ='$serviceid' order by id asc");
		 $res = mysql_fetch_array($query);
		 $areaid = $params['configoptions']['areaid'] ? $params['configoptions']['areaid'] : $params["configoption1"];
		 $nodeid= $params['configoptions']['nodeid'] ? $params['configoptions']['nodeid'] : $params["configoption2"];
		 $aspscript = $params['configoptions']['aspscript'] ? $params['configoptions']['aspscript'] : $params["configoption3"];
		 $aspxscript = $params['configoptions']['aspxscript'] ? $params['configoptions']['aspxscript'] : $params["configoption4"];
		 $phpscript = $params['configoptions']['phpscript'] ? $params['configoptions']['phpscript'] : $params["configoption5"];
		 $mysqlspace = $params['configoptions']['mysqlspace'] ? $params['configoptions']['mysqlspace'] : $params["configoption6"];
		 $mssqlspace = $params['configoptions']['mssqlspace'] ? $params['configoptions']['mssqlspace'] : $params["configoption7"];
		 $cpulimit = $params['configoptions']['cpulimit'] ? $params['configoptions']['cpulimit'] : $params["configoption8"];
		 $diskspace = $params['configoptions']['diskspace'] ? $params['configoptions']['diskspace'] : $params["configoption9"];
		 $bindingdomain = $params['configoptions']["bindingdomain"] ? $params['configoptions']['bindingdomain'] : $params["configoption10"];
		 $maxconnections = $params['configoptions']['maxconnections'] ? $params['configoptions']['maxconnections'] : $params["configoption11"]; //单位GB  为0不限制流量
		 $maxbandwidth = $params['configoptions']['maxbandwidth'] ? $params['configoptions']['maxbandwidth'] : $params["configoption12"]; //IP数量,如共享IP必须设1
		 $bwlimit = $params['configoptions']['bwlimit'] ? $params['configoptions']['bwlimit'] : $params["configoption13"]; 
		 $apppoolnum = $params['configoptions']['apppoolnum'] ? $params['configoptions']['apppoolnum'] : $params["configoption14"];
		 $hostip = $params['configoptions']['hostip'] ? $params['configoptions']['hostip'] : $params["configoption15"];
		 $phpversion = $params['configoptions']['phpversion'] ? $params['configoptions']['phpversion'] : $params["configoption16"];
		 $netversion = $params['configoptions']['netversion'] ? $params['configoptions']['netversion'] : $params["configoption17"]; //混合云（0=开公网IP主机  2=开内网IP主机 0=按全部节点可用IP池）
		 $netmode = $params['configoptions']['netmode'] ? $params['configoptions']['netmode'] : $params["configoption18"]; 
		$cname_def = $params["configoption19"];
		if($res["nextinvoicedate"]=='0000-00-00'){
			$res["nextinvoicedate"]='2099-01-01';
		}
		
		//获取用户信息注册RSTACK
		$query2 = mysql_query("SELECT * FROM `tblusers` WHERE id = ".$userid);
		$res2 = mysql_fetch_array($query2);
		
		//查询用户是否存在否则就创建
		$param = rstackVHOST_sign($params["serveraccesshash"]);
		$url = "http://".$params["serverhostname"]."/api/v3";
		$header = array();
		$data = array(
		    "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
            "api_type"=>$param["api_type"],
            "action"=>"user_info",
          	"userid"=>$userid
		);
		$rsret = rstackVHOST_post($url,$header,$data);
	
	
		if ($rsret ==""){
			$param = rstackVHOST_sign($params["serveraccesshash"]);
			$url = "http://".$params["serverhostname"]."/api/v3";
			$header = array();
			$data = array(
			    "api_sign"=>$param["api_sign"],
                "api_random"=>$param["api_random"],
                "api_timestamp"=>$param["api_timestamp"],
                "api_type"=>$param["api_type"],
    			"action"=>"user_add",
				"userid"=>$userid,
				"username"=>"whmcs".$userid,
				"password"=>$res2["password"],
				"email"=>$res2["email"],
				"remark"=>"WHMCS CREATE USERS"
			);
			$rsret = rstackVHOST_post($url,$header,$data);
			$ret = rstackVHOST_CheckReturn($rsret);
			if ($ret["code"]=="-1"){
				return array('success' => $ret["msg"]);
			}
		}
		
		$enable_mysql = "0";
		$enable_mssql = "0";
		if($mysqlspace != "" && $mysqlspace !="0"){
		    $enable_mysql = "1";
		}
		if ($mssqlspace !="" && $mssqlspace!="0"){
		    $enable_mssql = "1";
		}
		$mysqlbackupnum = "5"; //默认MYSQL允许备份5个，，可以自己修改
		$mssqlbackupnum = "5"; //默认MSSQL允许备份5个，可以自己修改
		
		$domains ="";
		if ($domain !=""){
		    if (strpos($domain,'.')!= false){
            	$domains = $domain;
            }

		}

		$param = rstackVHOST_sign($params["serveraccesshash"]);
		$url = "http://".$params["serverhostname"]."/api/v3";
        $header = array();
        $data = array(
            "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
            "api_type"=>$param["api_type"],
			"action"=>"vhost_create",
			"userid"=>$userid,
			"areaid"=>$areaid,
			"nodeid"=>$nodeid,
			"ftpname"=>$hostname,
			"ftppassword"=>$vpsPassword,
			"aspscript"=>$aspscript,
			"aspxscript"=>$aspxscript,
			"phpscript"=>$phpscript,
			"enable_mysql"=>$enable_mysql,
			"mysqlspace"=>$mysqlspace,
			"mysqlbackupnum"=>$mysqlbackupnum,
			"enable_mssql"=>$enable_mssql,
			"mssqlspace"=>$mssqlspace,
			"mssqlbackupnum"=>$mssqlbackupnum,
			"cpulimit"=>$cpulimit,//内存缓存（仅限动态内存有效）
			"diskspace"=>$diskspace,//内存权重 一般默认50
			"bindingdomain"=>$bindingdomain,
			"maxconnections"=>$maxconnections,
			"maxbandwidth"=>$maxbandwidth,
			"bwlimit"=>$bwlimit,
			"apppoolnum"=>$apppoolnum,
			"hostip"=>$hostip,
			"phpversion"=>$phpversion,
			"netversion"=>$netversion,
			"netmode"=>$netmode,
			'domains'=>$domains,
			//"XXXXXX"=>XXXXXX,
			"remark"=>"RSTACK WHMCS CREATE",
			"returnjson"=>"1"
        );
        ///XXXXXX
		$rsret = rstackVHOST_post($url,$header,$data);
		$ret = rstackVHOST_CheckReturn($rsret);
		if ($ret["code"]=="0") {
			//$query = mysql_query("SELECT id FROM tblhosting WHERE id ='$serviceid' order by id asc");
            //$res = mysql_fetch_array($query);
			$datas = json_decode($ret["msg"]);
			$ip = $datas->hostip;
			$cname = $datas->cname;
			$hostid = $datas->id; 
			//$ftppassword = $datas->ftppassword;
			
			if ($cname != "" && $cname_def =="cname" && $hostip ==""){
			    //如果选中显示CNAME，且是共享IP，那么在WHMCS主IP写入CNAME而不是IP
			    $ip = $cname;
			}
			//dedicatedip=主IP  assignedips = 类似附属备注IP
			if ($domain ==""){
			    //如果域名未输入那么域名=FTP名称
			    update_query("tblhosting",array("dedicatedip"=>$ip,"domain"=>$hostname,"username"=>$hostname,"subscriptionid"=>$hostid),array("id"=> $serviceid));
			}else{
			    
		    	update_query("tblhosting",array("dedicatedip"=>$ip,"username"=>$hostname,"subscriptionid"=>$hostid),array("id"=> $serviceid));
			}
		
			//更新订单，原WHMCS需要人工再次确认审核 才会激活，实际主机已开通了。如果不想手工在审核下 把注释去掉即可
			//update_query("tblorders",array("status"=>"Active"),array("id"=> $res["orderid"]));
			return 'success';
		} else {
			return array('error' => $ret["msg"]);
		}
	}
	
	
	//续费。
	function rstackVHOST_Renew($params){
		$hostname=$params["username"];
		$query = mysql_query("SELECT * FROM tblhosting WHERE username ='$hostname' order by id asc ");
		$res = mysql_fetch_array($query);
		
		$param = rstackVHOST_sign($params["serveraccesshash"]);
		$url = "http://".$params["serverhostname"]."/api/v3";
		$header = array();
		$data = array(
		    "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
			"update_host"=>"1",
			"action"=>"vhost_update", //默认强制关机，如果需要软关机 存kvm_stop（软不一定能关闭）
			"status"=>"2",//正常
            "id"=>$res["subscriptionid"]
        );
		$rsret = rstackVHOST_post($url,$header,$data);
		$ret = rstackVHOST_CheckReturn($rsret);
		if ($ret["code"]=="0") {
			return 'success';
		}else{
			return array('success' => $ret["msg"]);
		}
 	 }
	 
	  //过期续费 与 开机。 【模块名：解除暂停】
	function rstackVHOST_UnsuspendAccount($params){
		$hostname=$params["username"];
		$query = mysql_query("SELECT * FROM tblhosting WHERE username ='$hostname' order by id asc ");
		$res = mysql_fetch_array($query);
		
		$param = rstackVHOST_sign($params["serveraccesshash"]);
		$url = "http://".$params["serverhostname"]."/api/v3";
		$header = array();
		$data = array(
		    "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
			"update_host"=>"1",
			"action"=>"vhost_update", //默认强制关机，如果需要软关机 存kvm_stop（软不一定能关闭）
			"status"=>"2",//正常
            "id"=>$res["subscriptionid"]
        );
		$rsret = rstackVHOST_post($url,$header,$data);
		$ret = rstackVHOST_CheckReturn($rsret);
		if ($ret["code"]=="0") {
			return 'success';
		}else{
			return array('success' => $ret["msg"]);
		}
 	 }
	 
	//暂停主机
	function rstackVHOST_SuspendAccount($params){
		$hostname=$params["username"];
		$query = mysql_query("SELECT * FROM tblhosting WHERE username ='$hostname' order by id asc ");
		$res = mysql_fetch_array($query);
		
		$param = rstackVHOST_sign($params["serveraccesshash"]);
		$url = "http://".$params["serverhostname"]."/api/v3";
		$header = array();
		$data = array(
		    "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
			"update_host"=>"1",
			"action"=>"vhost_update", //默认强制关机，如果需要软关机 存kvm_stop（软不一定能关闭）
			"status"=>"1",//锁定
            "id"=>$res["subscriptionid"]
        );
		$rsret = rstackVHOST_post($url,$header,$data);
		$ret = rstackVHOST_CheckReturn($rsret);
		if ($ret["code"]=="0") {
			return 'success';
		}else{
			return array('success' => $ret["msg"]);
		}
	}
	
	//删除主机
	function rstackVHOST_TerminateAccount($params){
		$hostname = $params["username"];
		$query = mysql_query("SELECT * FROM tblhosting WHERE username ='$hostname' order by id asc ");
		$res = mysql_fetch_array($query);
		$param = rstackVHOST_sign($params["serveraccesshash"]);
		$url = "http://".$params["serverhostname"]."/api/v3";
		$header = array();
        $data = array(
            "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
            "hostid"=>$res["subscriptionid"],
            "action"=>"vhost_delete",
			"forcedelete"=>"1" //如果为1强制删除
        );
        $rsret = rstackVHOST_post($url,$header,$data);
		$ret = rstackVHOST_CheckReturn($rsret);
		if ($ret["code"]=="0") {
			//删除成功，将订单状态更改为取消。
			$query = mysql_query("SELECT * FROM tblhosting WHERE username ='$hostname' order by id asc");
            $res = mysql_fetch_array($query);
			update_query("tblorders",array("status"=>"Cancelled"),array("id"=> $res["orderid"]));
			return 'success';
		}else{
			return array('success' => $ret["msg"]);
		}
	}
	
	//升级套餐
	 function rstackVHOST_ChangePackage($params){
		 $hostname=$params["username"];
		 $query = mysql_query("SELECT * FROM tblhosting WHERE username ='$hostname' order by id asc ");
		 $res = mysql_fetch_array($query);
		 
		 $cpulimit = $params['configoptions']['cpulimit'] ? $params['configoptions']['cpulimit'] : $params["configoption8"];
		 $diskspace = $params['configoptions']['diskspace'] ? $params['configoptions']['diskspace'] : $params["configoption9"];
		 $bindingdomain = $params['configoptions']["bindingdomain"] ? $params['configoptions']['bindingdomain'] : $params["configoption10"];
		 $maxconnections = $params['configoptions']['maxconnections'] ? $params['configoptions']['maxconnections'] : $params["configoption11"]; //单位GB  为0不限制流量
		 $maxbandwidth = $params['configoptions']['maxbandwidth'] ? $params['configoptions']['maxbandwidth'] : $params["configoption12"]; //IP数量,如共享IP必须设1
		 $bwlimit = $params['configoptions']['bwlimit'] ? $params['configoptions']['bwlimit'] : $params["configoption13"]; 
		 $apppoolnum = $params['configoptions']['apppoolnum'] ? $params['configoptions']['apppoolnum'] : $params["configoption14"];
		 $hostip = $params['configoptions']['hostip'] ? $params['configoptions']['hostip'] : $params["configoption15"];
		 $phpversion = $params['configoptions']['phpversion'] ? $params['configoptions']['phpversion'] : $params["configoption16"];
		 $netversion = $params['configoptions']['netversion'] ? $params['configoptions']['netversion'] : $params["configoption17"]; //混合云（0=开公网IP主机  2=开内网IP主机 0=按全部节点可用IP池）
		 $netmode = $params['configoptions']['netmode'] ? $params['configoptions']['netmode'] : $params["configoption18"]; 
		 //判断是否免费
		if($res["nextinvoicedate"]=='0000-00-00'){
			$res["nextinvoicedate"]='2099-01-01';
		}
		$status = ""; //升级不更改状态。
		$remark = "";//备注
		$hostip = "";
        //($serverhostname,$apikey,$hostname,$cpulimit,$diskspace,$bindingdomain,$maxconnections,$maxbandwidth,$bwlimit,$hostip,$status,$remark
		$rsret = rstackVHOST_edit_host($params["serverhostname"], $params["serveraccesshash"],$hostname,$cpulimit,$diskspace,$$bindingdomain,$maxconnections,$maxbandwidth,$bwlimit,$hostip,$status,$remark);
		$ret = rstackVHOST_CheckReturn($rsret);
		if ($ret["code"]=="0") {
			return 'success';
		}else{
			return array('error' => $ret["msg"]);
		}
	 }

	 //修改原始密码
	 function rstackVHOST_ChangePassword($params){
		$hostname = $params["username"];
		$query = mysql_query("SELECT * FROM tblhosting WHERE username ='$hostname' order by id asc ");
		$res = mysql_fetch_array($query);
        $newftppass = 
		$param = rstackVHOST_sign($params["serveraccesshash"]);
		$url = "http://".$params["serverhostname"]."/api/v3";
		$header = array();
        $data = array(
            "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
			"action"=>"set_ftppassword",
            "hostid"=>$res["subscriptionid"],
			"new_ftppassword"=>rstackVHOST_generate_str(10,2)
        );
        $rsret = rstackVHOST_post($url,$header,$data);
		$ret = rstackVHOST_CheckReturn($rsret);
		if ($ret["code"]=="0") {
			return 'success';
		}else{
			return array('success' => $ret["msg"]);
		}
	 }
	 
	 	//编辑主机
	  function rstackVHOST_edit_host($serverhostname,$apikey,$hostname,$cpulimit,$diskspace,$bindingdomain,$maxconnections,$maxbandwidth,$bwlimit,$hostip,$status,$remark)
	  {
		  $query = mysql_query("SELECT * FROM tblhosting WHERE username ='$hostname' order by id asc");
		  $res = mysql_fetch_array($query);
		  $param = rstackVHOST_sign($apikey);
		  $url = "http://".$serverhostname."/api/v3";
		  $header = array();
		  $data = array(
		    "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
			"action"=>"vhost_update",
			"update_host"=>"1", //立刻更改硬件(如果硬件一致 系统不会重启和更改)
            "id"=>$res["subscriptionid"], 
			"cpulimit"=>$cpulimit,
			"diskspace"=>$diskspace,
			"bindingdomain"=>$bindingdomain,
			"maxconnections"=>$maxconnections,
			"maxbandwidth"=>$maxbandwidth,
			"bwlimit"=>$bwlimit,
			"hostip"=>$hostip,
			"status"=>$status,
			"remark"=>$remark
		   );
		   return rstackVHOST_post($url,$header,$data);
	  }
	  
	  
	function rstackVHOST_ConfigOptions()
	{
		$servergroup = $_POST["servergroup"];
		if ($servergroup == "0") {
			return array("<span style=\"color:#008000;\">请选择服务器分组！</span>"=>array());
		}

		$aspscript = [];
		$aspscript["0"] = "不支持";
		$aspscript["1"] = "支持";
		
		$aspxscript = [];
		$aspxscript["0"] = "不支持";
		$aspxscript["1"] = "支持";
		
		$phpscript = [];
		$phpscript["0"] = "不支持";
		$phpscript["1"] = "支持";
		
		 $is_share_ip= [];
		$is_share_ip[""] = "开通共享IP空间";
		$is_share_ip["1"] = "开通独立IP空间";
		
		$phpscript_def= [];
		$phpscript_def["5.2"] = "PHP5.2";
		$phpscript_def["5.3"] = "PHP5.3";
		$phpscript_def["5.4"] = "PHP5.4";
		$phpscript_def["5.5"] = "PHP5.5";
		$phpscript_def["5.6"] = "PHP5.6";
		$phpscript_def["7.0"] = "PHP7.0";
		$phpscript_def["7.1"] = "PHP7.1";
		$phpscript_def["7.2"] = "PHP7.2";
		$phpscript_def["7.3"] = "PHP7.3";
		$phpscript_def["7.4"] = "PHP7.4";
		$phpscript_def["8.1"] = "PHP8.1";
		
		$netversion_def= [];
		$netversion_def["2.0"] = "Net 2.0/3.5";
		$netversion_def["4.0"] = "Net 4.0";
		
		$netmode_def= [];
		$netmode_def["0"] = "经典(推荐)";
		$netmode_def["1"] = "集成";
		
		$cname_def= [];
		$cname_def["cname"] = "CName";
		$cname_def["ip"] = "IP";
	
		$configarray = array(
				"区域" => array("Type" => "text", "Size" => "5", "Description" => "如不选请指定节点(2选1)", "Default" => ""),         //1
				"计算节点" => array("Type" => "text", "Size" => "5","Description" => "如不选请指定区域(2选1)", "Default" => ""),         //2
				"ASP脚本" => array("Type" => "dropdown","Size" => "5", "Options" => $aspscript,"Description" => "","Default" => "0"), //3
				"ASPX脚本" => array("Type" => "dropdown","Size" => "5", "Options" => $aspxscript,"Description" => "","Default" => "0"), //4
				"PHP脚本" => array("Type" => "dropdown","Size" => "5", "Options" => $phpscript
				,"Description" => "","Default" => "0"), //5
				"赠送MYSQL" => array("Type" => "text", "Size" => "5", "Description" => "MB（留空不赠送）", "Default" => ""),         //6
				"赠送MSSQL" => array("Type" => "text", "Size" => "5", "Description" => "MB（留空不赠送）", "Default" => ""),    //7
				"CPU限制" => array("Type" => "text", "Size" => "5", "Description" => "%（仅对独立池有效）", "Default" => "100"),    //8
				"磁盘容量" => array("Type" => "text", "Size" => "5", "Description" => "MB（1024=1G）", "Default" => "1024"),    //9
				"域名绑定数" => array("Type" => "text", "Size" => "5", "Description" => "个（最小1）", "Default" => "20"), //10
			    "IIS连接数" => array("Type" => "text", "Size" => "5", "Description" => "个（推荐50以上）", "Default" => "200"), //11
			    "站点宽带" => array("Type" => "text", "Size" => "5", "Description" => "Mbps（最小1）", "Default" => "1"), //12
			    "流量限制" => array("Type" => "text", "Size" => "5", "Description" => "G（0为不限）", "Default" => "0"), //13
			    "站点池分配" => array("Type" => "text", "Size" => "5", "Description" => "个（多少站点共用一个池,1=独立池）", "Default" => "1"), //14
				"开通独立IP" => array("Type" => "dropdown","Size" => "5", "Options" => $is_share_ip,"Description" => "","Default" => "0"), //15
				"默认PHP版本" => array("Type" => "dropdown","Size" => "5", "Options" => $phpscript_def,"Description" => "","Default" => "0"), //16
				"默认NET版本" => array("Type" => "dropdown","Size" => "5", "Options" => $netversion_def,"Description" => "仅限独立池有效","Default" => "0"), //17
				"NET池模式" => array("Type" => "dropdown","Size" => "5", "Options" => $netmode_def,"Description" => "仅限独立池有效","Default" => "0"), //18
				"开通后显示IP或CNAME" => array("Type" => "dropdown","Size" => "5", "Options" => $cname_def,"Description" => "CNAME的话方便以后换IP","Default" => "0") //19
				
			);
		return $configarray;	
	}

	//测试WHMCS和RStack面板通信
	function rstackVHOST_TestConnection($params)
	{
		$data = rstackVHOST_test($params["serverhostname"], $params["serveraccesshash"]);
		$ret = rstackVHOST_CheckReturn($data);
		if ($ret["code"]=="0") {
			return array('success' => 'Test Success');
		} else {
			return array('error' => $ret["msg"]);
		}
	}
	
	 //测试连接
    function rstackVHOST_test($domain,$apikey)
    {
        //$domain = "192.168.1.23:9999";
        $param = rstackVHOST_sign($apikey);
		$url = "http://".$domain."/api/v3";
        $header = array();
		
        //参数
        $data = array(
            "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
            "api_language"=>"",
            "api_type"=>$param["api_type"],
            "action"=>"test"
        );
        return rstackVHOST_post($url,$header,$data);
    }
	
	function rstackVHOST_vhost_data($params){
		$hostname = $params["username"];
		$query = mysql_query("SELECT * FROM tblhosting WHERE username ='$hostname' order by id asc ");
		$res = mysql_fetch_array($query);
        $newftppass = 
		$param = rstackVHOST_sign($params["serveraccesshash"]);
		$url = "http://".$params["serverhostname"]."/api/v3";
		$header = array();
        $data = array(
            "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
			"action"=>"vhost_data",
            "id"=>$res["subscriptionid"]
        );
        $rsret = rstackVHOST_post($url,$header,$data);
      
	    return $rsret;
	 }
	 
	 function rstackVHOST_Power($serverhostname,$apikey,$hostname,$powertype)
    {
        $query = mysql_query("SELECT * FROM tblhosting WHERE username ='$hostname' order by id asc");
		$res = mysql_fetch_array($query);
        $param = rstackVHOST_sign($apikey);
        $url = "http://".$serverhostname."/api/v3";
        $header = array();
        $data = array(
            "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
			"action"=>$powertype,
            "hostid"=>$res["subscriptionid"]
        );
        return rstackVHOST_post($url,$header,$data);
    }
    
    function rstackVHOST_State($serverhostname,$apikey,$hostname)
    {
        $query = mysql_query("SELECT * FROM tblhosting WHERE username ='$hostname' order by id asc");
		$res = mysql_fetch_array($query);
        $param = rstackVHOST_sign($apikey);
        $url = "http://".$serverhostname."/api/v3";
        $header = array();
        $data = array(
            "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
			"action"=>"state",
            "hostid"=>$res["subscriptionid"]
        );
        return rstackVHOST_post($url,$header,$data);
    }
    
    function rstackVHOST_Monitor($serverhostname,$apikey,$hostname)
    {
        $query = mysql_query("SELECT * FROM tblhosting WHERE username ='$hostname' order by id asc");
		$res = mysql_fetch_array($query);
        $param = rstackVHOST_sign($apikey);
        $url = "http://".$serverhostname."/api/v3";
        $header = array();
        $data = array(
            "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
			"action"=>"vhost_monitor",
            "hostid"=>$res["subscriptionid"]
        );
        return rstackVHOST_post($url,$header,$data);
    }


    function rstackVHOST_Login_panel($serverhostname,$apikey,$hostname)
    {
        $query = mysql_query("SELECT * FROM tblhosting WHERE username ='$hostname' order by id asc");
		$res = mysql_fetch_array($query);
        $param = rstackVHOST_sign($apikey);
        $url = "http://".$serverhostname."/api/v3";
        $header = array();
        $data = array(
            "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
			"action"=>"vhost_data",
            "id"=>$res["subscriptionid"]
        );
        //返回JSON
        $vhostinfo = json_decode(rstackVHOST_post($url,$header,$data));
        $ftpname = $vhostinfo->ftpname;
        $ftppassword = $vhostinfo->ftppassword;
        $domainURL = "http://".$serverhostname."/";
	$str = "<html><head>"+
	"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">"+
	"</head><body>"+
	"<form name='submitpost' action='".$domainURL."process?c=login' method='post'> "+
	"<input type='hidden' name='logintype' value='vhost' />"+
	"<input type='hidden' name='username' value='.$ftpname.' />"+
	"<input type='hidden' name='password' value='.$ftppassword.' />"+
	"<script>document.forms['submitpost'].submit();</script>"+
	"</body></html>";
        return $str;
    }

	//客户端页输出
	function rstackVHOST_ClientArea($params){
		 if ($params["status"] != "Completed" and $params["status"] != "Active") {
			return 0;
		} else {
			function arg($name = null, $default = null, $trim = false)
			{
				if ($name) {
					if (!isset($_REQUEST[$name])) return $default;
					$arg = $_REQUEST[$name];
					if ($trim) $arg = trim($arg);
				} else {
					$arg = $_REQUEST;
				}
				return $arg;
			}
			
			$post = arg();
           
			$data[] = "";
			
			$hostname_ = $params["username"];
			$query = mysql_query("SELECT * FROM tblhosting WHERE username ='$hostname_' order by id asc");
			$res = mysql_fetch_array($query);
			
			//$host = json_decode(rstackVHOST_search_virtual($params["serverhostname"], $params["serveraccesshash"], $res["subscriptionid"]));
			$vhost_data = json_decode(rstackVHOST_vhost_data($params));
			//$vhost_data = rstackVHOST_vhost_data($params);
			
           
			switch ($post["a"]) {
				case "power":
                	exit(rstackVHOST_Power($params["serverhostname"], $params["serveraccesshash"], $params["username"],$post["powertype"]));
                	break;
                case "state":
                	exit(rstackVHOST_State($params["serverhostname"], $params["serveraccesshash"], $params["username"]));
                	break;
                case "vhost_monitor":
                    exit(rstackVHOST_Monitor($params["serverhostname"], $params["serveraccesshash"], $params["username"]));
                    break;
                case "login_panel":
                    exit(rstackVHOST_Login_panel($params["serverhostname"], $params["serveraccesshash"], $params["username"]));
                    break;
			}
			
           $host_name_0 = $params["username"]; 
           $query = mysql_query("SELECT * FROM tblhosting WHERE username ='$host_name_0' order by id asc ");
		   $tblhosting = mysql_fetch_array($query);
           
        
           
            return [
            'tabOverviewReplacementTemplate' => 'clientarea',
			//'templatefile' => 'clientarea',
            'vars' => [  
                'vhost_data' => $vhost_data,
              	'tblhosting' => $tblhosting,
              	'domainurl' => $params["serverhostname"]
				//'virtuals' => $nodes,
                //'xxx' => ''
            ]
        ];
            
		}
		//return $data;
	}
	
	
    //生成随机字符串
    function rstackVHOST_generate_str($length,$type) {
      // 密码字符集，可任意添加你需要的字符 
      if($type==1) {
        $chars = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789!@-_';
      } elseif($type==2) {
        $chars = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789';
      } else {
        $chars = 'abcdefghijklmnopqrstuvwxyz0123456789';
      }
      $password ='';
      for ( $i = 0; $i < $length; $i++ ) {
        // 这里提供两种字符获取方式 
        // 第一种是使用 substr 截取$chars中的任意一位字符； 
        // 第二种是取字符数组 $chars 的任意元素 
        // $password .= substr($chars, mt_rand(0, strlen($chars) – 1), 1); 
        $password .= $chars[ mt_rand(0, strlen($chars) - 1) ];
      }
      return $password;
    }

	
	//验证是否整数
	function rstackVHOST_isnumber($str){
		$result = false;
		if(preg_match("/^[0-9]+$/" ,$str)){
			$result = true;
		}
		return $result;
	}
	
	function rstackVHOST_object_array($array)
	{
		if (is_object($array)) {
			$array = (array)$array;
		}
		if (is_array($array)) {
			foreach ($array as $key => $value) {
				$array[$key] = rstackVHOST_object_array($value);
			}
		}
		return $array;
	}
	
	function rstackVHOST_CheckReturn($str){
		$tmp  = explode("|",$str);
		if (count($tmp)>2){
			return array(
				"code"=>"-1",
				"msg"=>"API返回格式不能出现多个|符号",
			);
		}else if (count($tmp) == 2){
			//带返回值 格式如  0|success
			return array(
				"code"=>$tmp[0],
				"msg"=>$tmp[1],
			);
		}else{
			if ($str == "0"){
				// 只返回 0 的接口
				return array(
					"code"=>$str,
					"msg"=>"",
				);
			}else{
				// 返回错误信息
				return array(
					"code"=>$tmp[0],
					"msg"=>$tmp[1],
				);
			}
		}
	}
	
	function rstackVHOST_CheckReturnJSON($str){
		$tmp  = explode("|",$str);
		if (count($tmp)>2){
			return array(
				"code"=>"-1",
				"msg"=>"API返回格式不能出现多个|符号",
			);
		}else if (count($tmp) == 2){
			//带返回值 格式如  0|success
			return array(
				"code"=>$tmp[0],
				"msg"=>$tmp[1],
			);
		}else{
				return array(
					"code"=>"0",
					"msg"=>"success",
					"data"=>$str,
				);
		}
	}
	
	function rstackVHOST_sign($apikey)
    {
        $api_timestamp = time();
		$api_random = rstackVHOST_GetRandStr(16);
        //加密MD5
		$api_sign = md5($apikey.$api_random.$api_timestamp);
        //返回sign签名
        return array(
            "api_sign"=>$api_sign,
            "api_timestamp"=>$api_timestamp,
            "api_random"=>$api_random,
            "api_language"=>"chinese",
            "api_type"=>virtualType
        );
    }
	

     // 发送POST请求
    function rstackVHOST_post($url,$header,$data){
        $cUrl = curl_init();
        curl_setopt($cUrl, CURLOPT_URL, $url);//目标URL
        curl_setopt($cUrl, CURLOPT_TIMEOUT,600);//超时时间
        curl_setopt($cUrl, CURLOPT_POST, true);	//POST请求
        curl_setopt($cUrl, CURLOPT_POSTFIELDS, http_build_query($data));//POST数据
        curl_setopt($cUrl, CURLOPT_RETURNTRANSFER, 1);//设置接收返回值
        curl_setopt($cUrl, CURLOPT_HTTPHEADER, $header);//请求头
        curl_setopt($cUrl, CURLOPT_HEADER, true);//请求头
        curl_setopt($cUrl, CURLOPT_SSL_VERIFYPEER, FALSE);//不验证证书
        curl_setopt($cUrl, CURLOPT_SSL_VERIFYHOST, FALSE);//不验证HOSTS
        $output = curl_exec($cUrl); //发送
        $headerSize = curl_getinfo($cUrl, CURLINFO_HEADER_SIZE);//获取响应头长度
        $body = substr($output, $headerSize); //获取内容
        curl_close($cUrl);//释放curl资源
        return $body;
    }
    
    function rstackVHOST_GetRandStr($length){
        $str = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789';
        $len = strlen($str)-1;
        $randstr = '';
        for ($i=0;$i<$length;$i++) {
            $num=mt_rand(0,$len);
            $randstr .= $str[$num];
        }
        return $randstr;
    }

	

	
		/*
	支持模块函数
	function rstackVHOST_ConfigOptions()
	function rstackVHOST_CreateAccount($params)
	function rstackVHOST_TerminateAccount($params)
	function rstackVHOST_SuspendAccount($params)
	function rstackVHOST_UnsuspendAccount($params)
	function rstackVHOST_ChangePassword($params)
	function rstackVHOST_ChangePackage($params)
	function rstackVHOST_ClientArea($params)
	function rstackVHOST_AdminLink($params)
	function rstackVHOST_LoginLink($params)
	function rstackVHOST_genkey($params)
	function rstackVHOST_uninstall($params)
	function rstackVHOST_ClientAreaCustomButtonArray()
	function rstackVHOST_AdminCustomButtonArray() {.
	function rstackVHOST_extrapage($params)
	function rstackVHOST_UsageUpdate($params)
	function rstackVHOST_AdminServicesTabFields($params)
	function rstackVHOST_AdminServicesTabFieldsSave($params)
	*/
	/*
        RStack云平台，复制请保留版权：http://www.rstack.com.cn/
    */
	