
function vhost_monitoring_view(serviceID){
	
	//$.get('/process?c=kvm_monitor_view&id='+virtuals_id+'&day='+day,function(rdata2){	
	$.get('/clientarea.php?action=productdetails&id='+serviceID+'&modop=custom&a=vhost_monitor',function(rdata2){	
		var rmsg = rdata2.split('|');
		if (rmsg[0] == "-1"){
			rdata2 = "[]";
		}
		//#CPU部分
		var rdata = $.parseJSON(rdata2)
		
	
		//网络
		var xData_Network = [];
        var yData_Network = [];
        var zData_Network = [];
		
		for(var i = 0; i < rdata.length; i++){

			
			xData_Network.push(rdata[i].times);
            yData_Network.push(rdata[i].network.split(',')[0]); //上行
            zData_Network.push(rdata[i].network.split(',')[1]); //下行
			/*
			var ex = /^\d+$/;
			if (!ex.test(str)) {
				
			}
			*/
        }
	
		//网络
		var myChartNetwork = echarts.init(document.getElementById('container4'));
		 option = {
            tooltip: {
                trigger: 'axis'
            },
            legend: {
                data:['上行','下行']
            },
            grid: {
                 x:40,
                 y:50,
                 x2:0,
                 y2:30
            },
            xAxis: {
                type: 'category',
                boundaryGap: false,
                data: xData_Network,
                axisLine:{
                    lineStyle:{
                        color:"#666"
                    }
                }
            },
            yAxis: {
                type: 'value',
                name: '带宽KB/s',
                boundaryGap: [0, '100%'],
                splitLine:{
                    lineStyle:{
                        color:"#ddd"
                    }
                },
                axisLine:{
                    lineStyle:{
                        color:"#666"
                    }
                }
            },
            series: [
                {
                    name:'上行',
                    type:'line',
                    smooth:true,
                    symbol: 'none',
                    sampling: 'average',
                    itemStyle: {
                        normal: {
                            color: 'rgb(240,128,128)'
                        }
                    },
                    data: yData_Network
                },
                {
                    name:'下行',
                    type:'line',
                    smooth:true,
                    symbol: 'none',
                    sampling: 'average',
                    itemStyle: {
                        normal: {
                            color: 'rgb(0,191,255)'
                        }
                    },
                    data: zData_Network
                }
            ]
        };
        myChartNetwork.setOption(option);
        window.addEventListener("resize",function(){
            myChartNetwork.resize();
        });
		
		
	}) //GET结束
}






//时间戳转时间模式
function formatDateTime(timeStamp) { 
		var date = new Date();
		date.setTime(timeStamp * 1000);
		var y = date.getFullYear();    
		var m = date.getMonth() + 1;    
		m = m < 10 ? ('0' + m) : m;    
		var d = date.getDate();    
		d = d < 10 ? ('0' + d) : d;    
		var h = date.getHours();  
		h = h < 10 ? ('0' + h) : h;  
		var minute = date.getMinutes();  
		var second = date.getSeconds();  
		minute = minute < 10 ? ('0' + minute) : minute;    
		second = second < 10 ? ('0' + second) : second;   
		return y + '-' + m + '-' + d+' '+h+':'+minute+':'+second;    
}

